using System;
using System.IO;
using System.Drawing;
using System.Windows.Forms;


namespace CHIP_Bitratenrechner
{
public class Fenster : System.Windows.Forms.Form /*die Klasse Fenster wird definiert*/
{
		/*Was wir brauchen, das wird katalogisiert*/
private System.Windows.Forms.TextBox Stunden;
		private System.Windows.Forms.Label label_Stunden;
private System.Windows.Forms.TextBox Minuten;
private System.Windows.Forms.TextBox Sekunden;
		private System.Windows.Forms.RichTextBox Ergebnis;
private System.Windows.Forms.TextBox ZielTonspuren;
		private System.Windows.Forms.Label label_ZielTonspuren;
private System.Windows.Forms.ComboBox AusgFramerate;
		private System.Windows.Forms.Label label_AusgFramerate;
private System.Windows.Forms.ComboBox Zielformat;
		private System.Windows.Forms.Label label_Zielformat;
private System.Windows.Forms.ComboBox Zielgroesse;
		private System.Windows.Forms.Label label_Zielgroesse;
private System.Windows.Forms.ComboBox ZielTonart;
private System.Windows.Forms.ComboBox ZielFramerate;
		private System.Windows.Forms.Label label_ZielFramerate;
		private System.Windows.Forms.PictureBox Logo;
private System.ComponentModel.Container components = null;
	
		public Fenster()
{
InitializeComponent();
}

		//Aufrumarbeiten
protected override void Dispose( bool disposing )
{
if( disposing)
{
if (components != null)
{
components.Dispose();
}
}
base.Dispose ( disposing );
}

		// Hauptprogramm
static void Main()
{
			Application.Run(new Fenster());
}
		
		//alles initialisieren
private void InitializeComponent()
{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Fenster));
			this.Stunden = new System.Windows.Forms.TextBox();
			this.label_Stunden = new System.Windows.Forms.Label();
			this.Minuten = new System.Windows.Forms.TextBox();
			this.Sekunden = new System.Windows.Forms.TextBox();
			this.Ergebnis = new System.Windows.Forms.RichTextBox();
			this.ZielTonspuren = new System.Windows.Forms.TextBox();
			this.label_ZielTonspuren = new System.Windows.Forms.Label();
			this.AusgFramerate = new System.Windows.Forms.ComboBox();
			this.label_AusgFramerate = new System.Windows.Forms.Label();
			this.Zielformat = new System.Windows.Forms.ComboBox();
			this.label_Zielformat = new System.Windows.Forms.Label();
			this.Zielgroesse = new System.Windows.Forms.ComboBox();
			this.label_Zielgroesse = new System.Windows.Forms.Label();
			this.ZielTonart = new System.Windows.Forms.ComboBox();
			this.ZielFramerate = new System.Windows.Forms.ComboBox();
			this.label_ZielFramerate = new System.Windows.Forms.Label();
			this.Logo = new System.Windows.Forms.PictureBox();
			this.SuspendLayout();
			
			// Stunden 
			this.Stunden.Location = new System.Drawing.Point(30, 30);
			this.Stunden.Name = "Stunden";
			this.Stunden.Size = new System.Drawing.Size(30, 20);
			this.Stunden.TabIndex = 0;
			this.Stunden.Text = "0";
			this.Stunden.TextChanged += new System.EventHandler(this.neue_Spielzeit);
			
			// label_Stunden 
			this.label_Stunden.Location = new System.Drawing.Point(30, 10);
			this.label_Stunden.Name = "label_Stunden";
			this.label_Stunden.Size = new System.Drawing.Size(130, 20);
			this.label_Stunden.Text = "Spielzeit in h:min:sec";
			
			// Minuten 
			this.Minuten.Location = new System.Drawing.Point(65, 30);
			this.Minuten.Name = "Minuten";
			this.Minuten.Size = new System.Drawing.Size(30, 20);
			this.Minuten.TabIndex = 1;
			this.Minuten.Text = "0";
			this.Minuten.TextChanged += new System.EventHandler(this.neue_Spielzeit);
			
			// Sekunden 
			this.Sekunden.Location = new System.Drawing.Point(100, 30);
			this.Sekunden.Name = "Sekunden";
			this.Sekunden.Size = new System.Drawing.Size(30, 20);
			this.Sekunden.TabIndex = 2;
			this.Sekunden.Text = "0";
			this.Sekunden.TextChanged += new System.EventHandler(this.neue_Spielzeit);
			
			// Ergebnis
			this.Ergebnis.Location = new System.Drawing.Point(30, 130);
			this.Ergebnis.Name = "Ergebnis";
			this.Ergebnis.Size = new System.Drawing.Size(120, 150);
			this.Ergebnis.TabIndex = 10;
			this.Ergebnis.Text = "";
			
			// ZielTonspuren 
			this.ZielTonspuren.Location = new System.Drawing.Point(250, 170);
			this.ZielTonspuren.Name = "ZielTonspuren";
			this.ZielTonspuren.Size = new System.Drawing.Size(20, 20);
			this.ZielTonspuren.TabIndex = 7;
			this.ZielTonspuren.Text = "1";
			this.ZielTonspuren.TextChanged += new System.EventHandler(this.Tonspuren);
			
			// label_ZielTonspuren 
			this.label_ZielTonspuren.Location = new System.Drawing.Point(250, 150);
			this.label_ZielTonspuren.Name = "label_ZielTonspuren";
			this.label_ZielTonspuren.Size = new System.Drawing.Size(120, 20);
			this.label_ZielTonspuren.Text = "Tonspuren/Art";
			
			// AusgFramerate 
			this.AusgFramerate.Items.AddRange(new object[] {
															   "Kino-NTSC (24)",
															   "TV-NTSC (29)",
															   "PAL (25)"});
			this.AusgFramerate.Location = new System.Drawing.Point(30, 80);
			this.AusgFramerate.Name = "AusgFramerate";
			this.AusgFramerate.Size = new System.Drawing.Size(120, 21);
			this.AusgFramerate.SelectedIndex = 0;
			this.AusgFramerate.TabIndex = 4;
			this.AusgFramerate.SelectedIndexChanged += new System.EventHandler(this.AusgFramerate_SelectedIndexChanged);
	
			// label_AusgFramerate 
			this.label_AusgFramerate.Location = new System.Drawing.Point(30, 60);
			this.label_AusgFramerate.Name = "label_AusgFramerate";
			this.label_AusgFramerate.Size = new System.Drawing.Size(120, 20);
			this.label_AusgFramerate.Text = "Framerate der Quelle";
			
			// Zielformat 
			this.Zielformat.Items.AddRange(new object[] {
															"DVD",
															"SVCD",
															"VCD"});
			this.Zielformat.Location = new System.Drawing.Point(250, 30);
			this.Zielformat.Name = "Zielformat";
			this.Zielformat.Size = new System.Drawing.Size(120, 21);
			this.Zielformat.SelectedIndex = 0;
			this.Zielformat.TabIndex = 5;
			this.Zielformat.SelectedIndexChanged += new System.EventHandler(this.Zielformat_SelectedIndexChanged);
			
			// label_Zielformat 
			this.label_Zielformat.Location = new System.Drawing.Point(250, 10);
			this.label_Zielformat.Name = "label_Zielformat";
			this.label_Zielformat.Size = new System.Drawing.Size(120, 20);
			this.label_Zielformat.Text = "gewnschte Video-Art";
			
			// Zielgroesse
			this.Zielgroesse.Items.AddRange(new object[] {
															 "DVD (4,7 GB)",
															 "CD70 (800 MB)",
															 "CD65 (740 MB)",
															 "2x CD70 (1600MB)"});
			this.Zielgroesse.Location = new System.Drawing.Point(250, 100);
			this.Zielgroesse.Name = "Zielgroesse";
			this.Zielgroesse.Size = new System.Drawing.Size(120, 21);
			this.Zielgroesse.SelectedIndex = 0;
			this.Zielgroesse.TabIndex = 6;
			this.Zielgroesse.SelectedIndexChanged += new System.EventHandler(this.Zielgroesse_SelectedIndexChanged);
			
			// label_Zielgroesse
			this.label_Zielgroesse.Location = new System.Drawing.Point(250, 80);
			this.label_Zielgroesse.Name = "label_Zielgroesse";
			this.label_Zielgroesse.Size = new System.Drawing.Size(120, 20);
			this.label_Zielgroesse.Text = "Ziel-Medium";
			
			// ZielTonart
			this.ZielTonart.Items.AddRange(new object[] {
															"AC3",
															"MP2"});
			this.ZielTonart.Location = new System.Drawing.Point(275, 170);
			this.ZielTonart.Name = "ZielTonart";
			this.ZielTonart.Size = new System.Drawing.Size(95, 21);
			this.ZielTonart.SelectedIndex = 0;
			this.ZielTonart.TabIndex = 8;
			this.ZielTonart.SelectedIndexChanged += new System.EventHandler(this.ZielTonart_SelectedIndexChanged);
			
			// ZielFramerate
			this.ZielFramerate.Items.AddRange(new object[] {
															   "NTSC (24)",
															   "PAL (25)"});
			this.ZielFramerate.Location = new System.Drawing.Point(250, 240);
			this.ZielFramerate.Name = "ZielFramerate";
			this.ZielFramerate.Size = new System.Drawing.Size(120, 21);
			this.ZielFramerate.SelectedIndex = 1;
			this.ZielFramerate.TabIndex = 9;
			this.ZielFramerate.SelectedIndexChanged += new System.EventHandler(this.ZielFramerate_SelectedIndexChanged);
			
			// label_ZielFramerate 
			this.label_ZielFramerate.Location = new System.Drawing.Point(250, 220);
			this.label_ZielFramerate.Name = "label_ZielFramerate";
			this.label_ZielFramerate.Size = new System.Drawing.Size(120, 20);
			this.label_ZielFramerate.Text = "Framerate des Ziels";
			
			// Logo
			this.Logo.Image = ((System.Drawing.Bitmap)(resources.GetObject("Logo.Image")));
			this.Logo.Location = new System.Drawing.Point(144, 8);
			this.Logo.Name = "Logo";
			this.Logo.Size = new System.Drawing.Size(96, 32);
			this.Logo.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
			
			// Fenster
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(390, 300);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.Logo,
																		  this.Stunden,
																		  this.label_Stunden,
																		  this.Minuten,
																		  this.Sekunden,
																		  this.ZielTonspuren,
																		  this.label_ZielTonspuren,
																		  this.Ergebnis,
																		  this.AusgFramerate,
																		  this.label_AusgFramerate,
																		  this.Zielformat,
																		  this.label_Zielformat,
																		  this.Zielgroesse,
																		  this.label_Zielgroesse,
																		  this.ZielTonart,
																		  this.ZielFramerate,
																		  this.label_ZielFramerate});
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "Fenster";
			this.Text = "CHIP-Bitraten-Rechner";
			this.Load += new System.EventHandler(this.Fenster_Load);
			this.ResumeLayout(false);

		}

		/*Jetzt die EventHandler fr das Programm*/
private void Fenster_Load(object sender, System.EventArgs e)
{
			/*leer*/
}

		private void neue_Spielzeit(object sender, System.EventArgs e)
		{
			Rechnen();
		}

		private void Tonspuren(object sender, System.EventArgs e)
		{
			if (Zielformat.SelectedIndex == 2)
			{
				ZielTonspuren.Text = "1";
			}

			Rechnen();
		}

		private void AusgFramerate_SelectedIndexChanged(object sender, System.EventArgs e)
{
			Rechnen();
}

		private void Zielformat_SelectedIndexChanged(object sender, System.EventArgs e)
{
			if (Zielformat.SelectedIndex == 0)
			{
				this.ZielTonart.SelectedIndex = 0; /*wenn DVD, dann Ton auf AC3 -- dient nur der Bedienungsfreundlichkeit*/
				this.Zielgroesse.SelectedIndex = 0;
			}
			else
			{
				this.ZielTonart.SelectedIndex = 1; /*wenn NICHT DVD, dann Ton auf MP2*/
			}

			Rechnen();
		}

private void Zielgroesse_SelectedIndexChanged(object sender, System.EventArgs e)
{
			/*Besser wre eine if-Schleife ohne break -- aber auch while mchte erklrt werden*/
			while (Zielformat.SelectedIndex == 0)
			{
				this.Zielgroesse.SelectedIndex = 0;
				break;
			}
			
			Rechnen();
}

private void ZielTonart_SelectedIndexChanged(object sender, System.EventArgs e)
{
			if (Zielformat.SelectedIndex != 0)
			{
				this.ZielTonart.SelectedIndex = 1; /*wenn NICHT DVD, dann Ton auf MP2 -- Zwang, da auch eine SVCD kein AC3 erlaubt*/
			}

			Rechnen();
}

		private void ZielFramerate_SelectedIndexChanged(object sender, System.EventArgs e)
{
			Rechnen();
}

		public void Rechnen()
		{
			/* alle Variablen anlegen, Standard-Werte zuweisen*/
			double r_Stunden = 1,
				r_Minuten = 1,
				r_Sekunden = 1,
				r_Spielzeit,
				r_Tonspuren = 1,
				r_Ton_Bit = 128,
				r_Zielgroesse = 35938304, 
				r_Gesamtrate, 
				r_Videorate, 
				r_AusgFramerate = 24, 
				r_Zielframerate = 25,
				r_Endspielzeit;


			
			/*mit Try... wird eine Umwandlung der Eingaben in "Spielzeit" in int-Variablen versucht, catch...fngt Fehler ab*/
			try
			{
				r_Stunden = Convert.ToDouble(this.Stunden.Text);
				r_Minuten = Convert.ToDouble(this.Minuten.Text);
				r_Sekunden = Convert.ToDouble(this.Sekunden.Text);
				r_Tonspuren = Convert.ToInt32(this.ZielTonspuren.Text);
			}

			catch(FormatException e) /*e enthlt die Fehlermeldung*/
			{ 
				MessageBox.Show("Die Spielzeit und die Tonspuren mssen in Zahlen angegeben werden.", "Formatfehler");
				this.Stunden.Text = "0";
				this.Minuten.Text = "0";
				this.Sekunden.Text = "0";
			}

			catch(OverflowException e)
			{
				MessageBox.Show("Die Zahl ist zu gro.", "Overflow");
				this.Stunden.Text = "0";
				this.Minuten.Text = "0";
				this.Sekunden.Text = "0";
			}

			if (r_Tonspuren > 2 && Zielformat.SelectedIndex == 1)
			{
				this.ZielTonspuren.Text = "2";	/*eine SVCD kann nur zwei Tonspuren enthalten*/
				r_Tonspuren = 2;
			}



			
			/*ComboBox "Zielgroesse" wird ausgewertet*/
			switch(Zielgroesse.SelectedIndex)
			{
				case 0:
					r_Zielgroesse = 35938304; /*Speicherplatz einer DVD4.7 in KBit*/
					break;

				case 1:
					r_Zielgroesse = 6430720; /*Speicherplatz einer CD70 in KBit*/
					break;

				case 2:
					r_Zielgroesse = 5939200; /*Speicherplatz einer CD65 in KBit*/
					break;

				case 3:
					r_Zielgroesse = 12861440; /*Speicherplatz von zwei CD70-Rohlingen*/
					break;
			}

			/*ComboBox AusgFramerate wird ausgewertet*/
			switch(AusgFramerate.SelectedIndex)
			{
				case 0:
					r_AusgFramerate = 24;
					break;

				case 1:
					r_AusgFramerate = 29;
					break;

				case 2:
					r_AusgFramerate = 25;
					break;
			}
			
			switch(ZielFramerate.SelectedIndex)
			{
				case 0:
					r_Zielframerate = 24;
					break;

				case 1:
					r_Zielframerate = 25;
					break;
			}

			/*Bitrate fr Ton vom Format herleiten*/
			if (ZielTonart.SelectedIndex == 0 && Zielgroesse.SelectedIndex == 0)
			{
				r_Ton_Bit = 384;
			}
			else
			{
				if (ZielTonart.SelectedIndex == 1 && Zielgroesse.SelectedIndex == 0)						
				{
					r_Ton_Bit = 224;
				}
			
				else
				{
					r_Ton_Bit = 128;
				}
			}

			/*Abfragen fertig, endlich RECHNEN!*/
			r_Spielzeit = (r_Stunden * 3600) + (r_Minuten * 60) + r_Sekunden;
			r_Endspielzeit = (r_Spielzeit * r_AusgFramerate) / r_Zielframerate;
			
			if (r_Endspielzeit == 0)  /*Schutz vor Division by Zero */
			{
				r_Endspielzeit = 1;
			}


			r_Gesamtrate = r_Zielgroesse / r_Endspielzeit;
			
			/*das Nachfolgende lsst sich auch in die Switch-Anweisung packen - allerdings muss dann die if-Berechnung
			 *vor der r_Videorate-Berechnung stehen, die einzelnen case-Anweisungen folgen nach r_Videorate*/

			if ((Zielformat.SelectedIndex == 2) && ((r_Gesamtrate - (224 * r_Tonspuren)) > 1150))
			{
				r_Ton_Bit = 224;
			}

			if ((Zielformat.SelectedIndex == 1) && ((r_Gesamtrate - (224 * r_Tonspuren)) > 1900))
			{
				r_Ton_Bit = 224;
			}

			if ((Zielformat.SelectedIndex == 0) && ((r_Gesamtrate - (448 * r_Tonspuren)) > 2500))
			{
				if (ZielTonart.SelectedIndex == 0)
				{
					r_Ton_Bit = 448;
				}
				if (ZielTonart.SelectedIndex != 0)
				{
					r_Ton_Bit = 224;
				}
			}
			
			
			r_Videorate = r_Gesamtrate - (r_Ton_Bit  * r_Tonspuren);
			r_Videorate = r_Videorate*1.024; /*alle Encoder rechnen auf der 1000er-Basis - deshalb wird das bei der Ausgabe bercksichtigt*/

			switch(Zielformat.SelectedIndex)
			{
				case 0:
				{
					if (r_Videorate > 8000)
					{
						r_Videorate = 8000;
					}
					break;
				}
				case 1:
				{
					if (r_Videorate > 2600)
					{
						r_Videorate = 2600;
					}
					break;
				}
				case 2:
				{
					if (r_Videorate > 1150)
					{
						r_Videorate = 1150;
					}
					this.ZielTonspuren.Text = "1";
					break;
				}
			}

			r_Videorate = Math.Round(r_Videorate,3);  /*maximal drei Nachkomma-Werte !!rundet nicht kaufmnnisch!!*/


			if (r_Videorate < 0)
			{
				this.Ergebnis.Text = "Film zu lang, allein die Audio-Daten wrden das Medium fllen!";
				this.Ergebnis.BackColor = Color.IndianRed;
			}
			
			else 
			{
				if ((Zielformat.SelectedIndex == 1 && r_Videorate < 1300) || (Zielformat.SelectedIndex == 0 && r_Videorate < 2000))
				{
					this.Ergebnis.Text = "Das Bild wird unansehnlich.\n\nDurchschnitts-Bitrate Video: " + r_Videorate + " KBit/s\nAudio: " + r_Ton_Bit +" KBit pro Spur";
					this.Ergebnis.BackColor = Color.IndianRed;
				}
				else
				{
					if ((Zielformat.SelectedIndex != 0) && (Zielgroesse.SelectedIndex == 0))
					{
						this.Ergebnis.Text = "Eine SVCD oder VCD auf DVD gebrannt - das wird kein DVD-Player spielen.\n\nDurchschnitts-Bitrate Video: " + r_Videorate + " KBit/s\nAudio: " + r_Ton_Bit +" KBit pro Spur";
						this.Ergebnis.BackColor = Color.IndianRed;
					}
					else
					{
						if (Zielformat.SelectedIndex == 2 && r_Videorate < 1150)
						{
							this.Ergebnis.Text = "Film ist zu lang. Bitte whlen Sie ein greres Medium.";
							this.Ergebnis.BackColor = Color.IndianRed;
						}
						else
						{
							this.Ergebnis.Text = "Durchschnitts-Bitrate Video: " + r_Videorate + " KBit/s\nAudio: " + r_Ton_Bit +" KBit pro Spur";
							this.Ergebnis.BackColor = Color.White;
						}
					}
				}
			}
		}
	}
}
